/**
 *	@file	Donut.cpp
 *	@brief	main source file for Donut.exe
 */

#include "stdafx.h"
#include "resource.h"

#include "DonutDefine.h"
#include "ItemIDList.h"
#include "mtl.h"

#include "ExMenu.h"
#include "ToolTipManager.h"
#include "DonutPFunc.h"

#include "DonutFavoritesMenu.h"
#include "DonutOptions.h"
#include "DonutSecurityZone.h"
#include "DonutSimpleEventManager.h"

// drafts
#include "DialogKiller.h"
#include "ReBarVerticalBorder.h"
#include "FileNotification.h"
#include "FlatComboBox.h"
// ENDED

#include "Donut.h"
#include "MainFrameFileDropTarget.h"
#include "DonutView.h"
#include "DonutClipboardBar.h"
#include "DonutRebarCtrl.h"
#include "FavTreeViewCtrl.h"
#include "DonutPanelBar.h"
#include "PluginBar.h"

#include "DonutExplorerBar.h"
#include "DonutLinksBarCtrl.h"
#include "DonutToolBar.h"
#include "DonutStatusBarCtrl.h"

#include "AddressBar.h"
#include "SearchBar.h"
#include "MDITabCtrl.h"

#include "FavoriteMenu.h"

#include "initguid.h"
#include "DonutP.h"
#include "DonutP_i.c"

#include "ie_feature_control.h"
//+++ #include "FileCriticalSection.h"				//+++ ʂ̕@Ƃ̂ŁAsvɂȂ.
#include "MDIChildUserMessenger.h"
#include "dialog/aboutdlg.h"
#include "ChildFrm.h"
#include "MainFrm.h"

#include "API.h"

#ifdef USE_ATL3_BASE_HOSTEX /*_ATL_VER < 0x700*/	//+++
#include "for_ATL3/AtlifaceEx_i.c"
#endif


// Ini file name
TCHAR				g_szIniFileName[MAX_PATH];
extern const int	g_LIGHTMAX		= 5;
//+++ DonutPFunc.cppֈړ.
//x extern const char	g_cSeparater[]	= _T("");

#if 0 //def USE_ORG_UNDONUT_INI
const LPCTSTR		g_lpszLight[] = {
	"<span id='DonutP' style='color:black;background:FFFF00'>",
	"<span id='DonutP' style='color:black;background:00FFFF'>",
	"<span id='DonutP' style='color:black;background:FF00FF'>",
	"<span id='DonutP' style='color:black;background:7FFF00'>",
	"<span id='DonutP' style='color:black;background:1F8FFF'>"
};
#else
const LPCTSTR		g_lpszLight[] = {
	"<span id='Donut' style='color:black;background:FFFF00'>",
	"<span id='Donut' style='color:black;background:00FFFF'>",
	"<span id='Donut' style='color:black;background:FF00FF'>",
	"<span id='Donut' style='color:black;background:7FFF00'>",
	"<span id='Donut' style='color:black;background:1F8FFF'>"
};
#endif


extern const UINT	g_uDropDownCommandID[] = {
	ID_FILE_NEW,
	ID_VIEW_BACK,
	ID_VIEW_FORWARD,
	ID_FILE_NEW_CLIPBOARD2,
	ID_DOUBLE_CLOSE,
	ID_DLCTL_CHG_MULTI,
	ID_DLCTL_CHG_SECU,
	ID_URLACTION_COOKIES_CHG,
	ID_RECENT_DOCUMENT
};

extern const UINT	g_uDropDownWholeCommandID[] = {
	ID_VIEW_FONT_SIZE,
	ID_FAVORITES_DROPDOWN,
	ID_AUTO_REFRESH,
	ID_TOOLBAR,
	ID_EXPLORERBAR,
	ID_MOVE,
	ID_OPTION,
	ID_COOKIE_IE6,
	ID_FAVORITES_GROUP_DROPDOWN,
	ID_CSS_DROPDOWN
};


extern const int	g_uDropDownCommandCount 	 = sizeof (g_uDropDownCommandID 	) / sizeof (UINT);
extern const int	g_uDropDownWholeCommandCount = sizeof (g_uDropDownWholeCommandID) / sizeof (UINT);

#if 0	//+++ option/DLControlOption.cpp ֈړ.
TCHAR				CDLControlOption::s_szUserAgent[MAX_PATH];					// UDT DGSTR
#endif
#if 0	//+++ StartUpOption.cppֈړ.
TCHAR				CStartUpOption::s_szDfgPath[MAX_PATH];
#endif

bool				g_bNoReposition 		  = FALSE;

CServerAppModule	_Module;
CMainFrame *		g_pMainWnd				  = NULL;
CAPI *				g_pAPI					  = NULL;



BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_API, CAPI)
END_OBJECT_MAP()


static void CommandLineArg(CMainFrame& wndMain, LPTSTR lpstrCmdLine);



#if 1	//+++	NςȂ̃`FbN.
static bool CheckOneInstance(HINSTANCE hInstance, LPTSTR lpstrCmdLine)
{
	TCHAR	iniFilePath[MAX_PATH+16];
	iniFilePath[0] = '\0';
	::GetModuleFileName(hInstance, iniFilePath, MAX_PATH);
	size_t	l = ::_tcslen(iniFilePath);
	if (l < 5)
		return false;
	::_tcscpy(&iniFilePath[l-4], _T(".ini"));
	CMainOption::s_dwMainExtendedStyle = ::GetPrivateProfileInt(_T("Main"), _T("Extended_Style"), 0, iniFilePath);
	if (CMainOption::s_dwMainExtendedStyle & MAIN_EX_ONEINSTANCE) { // guarantee one instance
		//x HWND hWnd = ::FindWindow(_T("WTL:Donut"), NULL);
		HWND hWnd = ::FindWindow(DONUT_WND_CLASS_NAME, NULL);

		if (hWnd) {
			ATOM nAtom = ::GlobalAddAtom(lpstrCmdLine);
			::PostMessage(hWnd, WM_NEWINSTANCE, (WPARAM) nAtom, 0);
			return true;
		}
	}
	return false;
}
#endif



static bool _PrivateInit( /*const*/ CString strCmdLine)
{
	MtlIniFileNameInit(g_szIniFileName, _MAX_PATH);
  #if 0
	CIniFileI	pr( g_szIniFileName, _T("Main") );
	pr.QueryValue( CMainOption::s_dwMainExtendedStyle, _T("Extended_Style") );
	pr.Close();

	if (CMainOption::s_dwMainExtendedStyle & MAIN_EX_ONEINSTANCE) { // guarantee one instance
		//x HWND hWnd = ::FindWindow(_T("WTL:Donut"), NULL);
		HWND hWnd = ::FindWindow(DONUT_WND_CLASS_NAME, NULL);

		if (hWnd) {
			//if (!strCmdLine.IsEmpty()) { // 󂾂ƃANeBuɂłȂ
			ATOM nAtom = ::GlobalAddAtom(strCmdLine);
			::PostMessage(hWnd, WM_NEWINSTANCE, (WPARAM) nAtom, 0);
			//}
			return false;
		}
	}
  #endif

	CMainOption::GetProfile();
	CDLControlOption::GetProfile();
	CIgnoredURLsOption::GetProfile();
	CCloseTitlesOption::GetProfile();
	CFileNewOption::GetProfile();
	CStartUpOption::GetProfile();
	CDonutConfirmOption::GetProfile();
	CStyleSheetOption::GetProfile();

	ie_feature_control_setting();		//+++

	CFavoritesMenuOption::Init();
  #if 0 //+++ ʂŐ䂷悤ɂ̂ŁAsv
	CFileCriticalSection::Init();
  #endif

	CSkinOption::GetProfile();
	CThemeDLLLoader::LoadThemeDLL();
	CExMenuManager::Initialize();

	return true;
}



static void _PrivateTerm()
{
	CMainOption::WriteProfile();
	CDLControlOption::WriteProfile();
	CIgnoredURLsOption::WriteProfile();
	CCloseTitlesOption::WriteProfile();
	CFileNewOption::WriteProfile();
	CStartUpOption::WriteProfile();
	CDonutConfirmOption::WriteProfile();
	CStyleSheetOption::WriteProfile();

	CFavoritesMenuOption::Term();
  #if 0 //+++ ʂŐ䂷悤ɂ̂ŁAsv
	CFileCriticalSection::Term();
  #endif

	CThemeDLLLoader::UnLoadThemeDLL();
	CExMenuManager::Terminate();

	// don't forget
	CHlinkDataObject::Term();
}



static int Run(LPTSTR lpstrCmdLine = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
	CMessageLoop theLoop;

	_Module.AddMessageLoop(&theLoop);

	CMainFrame	 wndMain;

	if (wndMain.CreateEx() == NULL) {
		ATLTRACE( _T("Main window creation failed!\n") );
		return 0;
	}

	g_pMainWnd = &wndMain;

	// load windowplacement
  #if 1 	//+++
	wndMain.startupMainFrameStayle(nCmdShow);
  #else
	CIniFileI  pr( g_szIniFileName, _T("Main") );
	//MessageBox(wndMain.m_hWnd,_T("\̐ݒs܂"),_T("test"),MB_OK);
	MtlGetProfileMainFrameState_Chance( pr, wndMain, nCmdShow, CMainFrame::_Function_FullScreen(wndMain) );
	pr.Close();
  #endif

	_Module.Lock();

	if (lpstrCmdLine == 0 || lpstrCmdLine[0] == 0) {	// no command line param
	  #if 1 //+++ X^[gy[W̕\sOɁȀȂׂs킹.
		if (ForceMessageLoop() == 0)
			return 0;				// ̒iKŏIꂿĂA
	  #endif
		CStartUpOption::StartUp(wndMain);
	} else {
		if (CStartUpOption::s_dwParam)
			CStartUpOption::StartUp(wndMain);
		CommandLineArg(wndMain, lpstrCmdLine);
	}

  #if 1 //+++
   #if 1	//+++ CmainFrameɍsĂAobNAbv̊JnÃ^C~Oɂ炵Ă݂.
	//+++ X^[gy[W̕\As郁bZ[Wɂ΂Ă.
	//	  ...Ȃׂŏ̃y[W\̏łAXVJn(ɂȂĂق..ȂĂȂ)
	if (ForceMessageLoop() == 0)
		return 0;				// ̒iKŏIꂿĂA
	g_pMainWnd->SetAutoBackUp();		//XVȂAJn.
   #endif

	// ۂ̃C[v.
	int nRet = -1;
	try {
		nRet = theLoop.Run();
	} catch (...) {
		ErrorLogPrintf("Donut̃C[vŗO\n");
		ATLASSERT(0);
	}

	try {
		_Module.RemoveMessageLoop();
	} catch (...) {
		ErrorLogPrintf("_Module.RemoveMessageLoopŗO\n");
		ATLASSERT(0);
	}
  #else
	int nRet = theLoop.Run();
	_Module.RemoveMessageLoop();
  #endif

	return nRet;		//  WTL̃CN[Y1𐳏lƂĕԂĂ̂Œ.
}


static void CommandLineArg(CMainFrame& wndMain, LPTSTR lpstrCmdLine)
{
	// UDT DGSTR@( dai
	CString 	 strCmdLine(lpstrCmdLine);
	if (strCmdLine.CompareNoCase( _T("/dde") ) != 0) {	// it's not from dde. (if dde, do nothing.)
		ATLTRACE(_T("it's not from dde!(%s)\n"), strCmdLine);
		// UDT DGSTR ( Shell Open )
		// in dup running , check WM_NEWINSTANCE.
		// fixed by JOBBY . thx ( local check , remove quota.
		int nPos = 0;
		if (strCmdLine.Left(4).CompareNoCase( _T("http") ) == 0) {
			while (1) {
				nPos	   = strCmdLine.Find( _T(" ") );
				if (nPos == -1) {
					wndMain.OnUserOpenFile(strCmdLine , 0);
					break;
				} else
					wndMain.OnUserOpenFile(strCmdLine.Left(nPos) , 0);
				strCmdLine = strCmdLine.Mid(nPos + 1);
			}
		} else {
			// remove first & last double-quotation
			if (strCmdLine.GetAt(0) == '"')
				strCmdLine = strCmdLine.Mid(1, strCmdLine.GetLength() - 2);
			wndMain.OnUserOpenFile( strCmdLine, DonutGetStdOpenFlag() );
		}
	}
}




static HRESULT CreateComponentCategory(CATID catid, WCHAR *catDescription)
{
	ICatRegister *pcr = NULL;
	HRESULT 	  hr  = S_OK ;

	hr	= CoCreateInstance(CLSID_StdComponentCategoriesMgr,NULL,CLSCTX_INPROC_SERVER,IID_ICatRegister,(void **) &pcr);
	if ( FAILED(hr) )
		return hr;

	// Make sure the HKCR\Component Categories\{..catid...}
	// key is registered.
	CATEGORYINFO  catinfo;
	catinfo.catid	= catid;
	catinfo.lcid	= 0x0409 ; // english

	// Make sure the provided description is not too long.
	// Only copy the first 127 characters if it is.
	int 		  len = (int) wcslen(catDescription);
	if (len > 127)
		len = 127;

	wcsncpy(catinfo.szDescription, catDescription, len);

	// Make sure the description is null terminated.
	catinfo.szDescription[len] = '\0';

	hr	= pcr->RegisterCategories(1, &catinfo);
	pcr->Release();

	return hr;
}



static HRESULT RegisterCLSIDInCategory(REFCLSID clsid, CATID catid)
{
	// Register your component categories information.
	ICatRegister *pcr = NULL ;
	HRESULT 	  hr  = S_OK ;

	hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr, NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void **) &pcr);
	if ( SUCCEEDED(hr) ) {
		// Register this category as being "implemented" by the class.
		CATID rgcatid[1] ;
		rgcatid[0] = catid;
		hr		   = pcr->RegisterClassImplCategories(clsid, 1, rgcatid);
	}

	if (pcr != NULL)
		pcr->Release();

	return hr;
}


static HRESULT UnRegisterCLSIDInCategory(REFCLSID clsid, CATID catid)
{
	ICatRegister *pcr = NULL ;
	HRESULT 	  hr  = S_OK ;

	hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr, NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void **) &pcr);
	if ( SUCCEEDED(hr) ) {
		// Unregister this category as being "implemented" by the class.
		CATID rgcatid[1] ;
		rgcatid[0] = catid;
		hr		   = pcr->UnRegisterClassImplCategories(clsid, 1, rgcatid);
	}

	if (pcr != NULL)
		pcr->Release();

	return hr;
}



static int RegisterCOMServer(int &nRet, bool &bRun, bool &bAutomation)
{
	HRESULT hRes;
	TCHAR	szTokens[] = _T("-/");

	LPCTSTR lpszToken  = _Module.FindOneOf(::GetCommandLine(), szTokens);

	while (lpszToken != NULL) {
		if (lstrcmpi( lpszToken, _T("UnregServer") ) == 0) {
			nRet = _Module.UnregisterServer();
			nRet = UnRegisterCLSIDInCategory(CLSID_API, CATID_SafeForInitializing);
			if ( FAILED(nRet) )
				return nRet;

			nRet = UnRegisterCLSIDInCategory(CLSID_API, CATID_SafeForScripting);
			if ( FAILED(nRet) )
				return nRet;

			::MessageBox(NULL, _T("COMT[o[폜܂B"), _T("unDonut"), 0);
			bRun = false;
			break;

		} else if (lstrcmpi( lpszToken, _T("RegServer") ) == 0) {
			nRet = _Module.RegisterServer(TRUE, &CLSID_API);
			if (nRet == S_OK) {
				// Mark the control as safe for initializing.
				hRes = CreateComponentCategory(CATID_SafeForInitializing, L"Controls safely initializable from persistent data");
				if ( FAILED(hRes) )
					return hRes;

				hRes = RegisterCLSIDInCategory(CLSID_API, CATID_SafeForInitializing);
				if ( FAILED(hRes) )
					return hRes;

				// Mark the control as safe for scripting.
				hRes = CreateComponentCategory(CATID_SafeForScripting, L"Controls that are safely scriptable");
				if ( FAILED(hRes) )
					return hRes;

				hRes = RegisterCLSIDInCategory(CLSID_API, CATID_SafeForScripting);
				if ( FAILED(hRes) )
					return hRes;
				::MessageBox(NULL, _T("COMT[o[o^܂B"), _T("unDonut"), 0);
			} else
				::MessageBox(NULL, _T("COMT[o[o^s܂B"), _T("unDonut"), 0);

			bRun = false;
			break;
		} else if ( (lstrcmpi( lpszToken, _T("Automation") ) == 0)
				  || (lstrcmpi( lpszToken, _T("Embedding") ) == 0) )
		{
			bAutomation = true;
			break;
		}

		lpszToken = _Module.FindOneOf(lpszToken, szTokens);
	}

	return S_OK;
}


int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
  #if defined (_DEBUG)
	//[Nop
	//::_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF
	//			| _CRTDBG_CHECK_ALWAYS_DF
	// );
	//_CrtSetBreakAlloc(874);
  #endif

	if (CheckOneInstance(hInstance, lpstrCmdLine))
		return 0;

	g_pMainWnd	 = NULL;
//	HRESULT hRes = ::CoInitialize(NULL);
	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
	ATLASSERT( SUCCEEDED(hRes) );
	hRes		 = ::OleInitialize(NULL);
	// If you are running on NT 4.0 or higher you can use the following call instead to
	// make the EXE free threaded. This means that calls come in on a random RPC thread.
	//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT( SUCCEEDED(hRes) );

	ATLTRACE(_T("tWinMain : \n"), lpstrCmdLine);

 #if (_WIN32_IE >= 0x0300)
	INITCOMMONCONTROLSEX iccx;
	iccx.dwSize = sizeof (iccx);
	iccx.dwICC	= ICC_COOL_CLASSES | ICC_BAR_CLASSES | ICC_USEREX_CLASSES;
	int 	ret = ::InitCommonControlsEx(&iccx);
	ret;
	ATLASSERT(ret);
 #else
	::InitCommonControls();
 #endif

	hRes	= _Module.Init(ObjectMap, hInstance, &LIBID_ATLLib);
//hRes	= _Module.Init(NULL, hInstance);
	ATLASSERT( SUCCEEDED(hRes) );

	int 	nRet		 = 0;
	bool	bRun		 = true;
	bool	bAutomation = false;

	try {	//+++ ÔߗO`FbN.
		nRet = _PrivateInit(lpstrCmdLine);
	} catch (...) {
		ErrorLogPrintf("_PrivateInitŃG[\n");
		nRet = -1;
	}
	if (nRet <= 0)
		goto END_APP;

	AtlAxWinInit();

	//R}hC͂ɂĂCOMT[o[o^yщs
	nRet		= RegisterCOMServer(nRet, bRun, bAutomation);
	if ( FAILED(nRet) ) {
		ErrorLogPrintf("RegisterCOMServerŃG[\n");
		nRet = -1;
		goto END_APP;
	}

	CDonutSimpleEventManager::RaiseEvent(EVENT_PROCESS_START);

	if (bRun) {
		_Module.StartMonitor();
		hRes = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER, REGCLS_MULTIPLEUSE | REGCLS_SUSPENDED);
		ATLASSERT( SUCCEEDED(hRes) );
		hRes = ::CoResumeClassObjects();
		ATLASSERT( SUCCEEDED(hRes) );

		if (bAutomation) {
			CMessageLoop theLoop;
			nRet = theLoop.Run();
		} else {
			nRet = Run(lpstrCmdLine, nCmdShow);
		}
	  #if 1 //+++ WTL̃CN[YIɁAIR[hƂ1Ԃ...
			//+++ OSɕԂlȂ̂0̂ق悢͂ŁAdonut̑̕ł0ɂĂ悤Ȃ̂
			//+++ Ȃ̂ŁAIɕϊ.
		if (nRet == 1)
			nRet = 0;
	  #endif

		_Module.RevokeClassObjects();
		::Sleep(_Module.m_dwPause);
	}

	try {	//+++ ӖȂ낤ACx߂ŗO`FbN.
		_PrivateTerm();
	} catch (...) {
		ErrorLogPrintf("_PrivateTerm()ŗO\n");
		nRet = -1;
	}

  END_APP:
	try {	//+++ ӖȂ낤ACx߂ŗO`FbN.
		_Module.Term();
	} catch (...) {
		ErrorLogPrintf("_Module.Term()ŗO\n");	//MessageBox(NULL,"O܂B","O",MB_OK);
		nRet = -1;
	}

	try {	//+++ ӖȂ낤ACx߂ŗO`FbN.
		::OleUninitialize();
	} catch (...) {
		ErrorLogPrintf("::OleUninitialize()ŗO\n");
		nRet = -1;
	}
	try {	//+++ ӖȂ낤ACx߂ŗO`FbN.
		::CoUninitialize();
	} catch (...) {
		ErrorLogPrintf("::CoUninitialize()ŗO\n");
		nRet = -1;
	}

	CDonutSimpleEventManager::RaiseEvent(EVENT_PROCESS_END);
	return nRet;
}



/////////////////////////////////////////////////////////////////////////////


// CChildFrame
void CChildFrame::PreDocumentComplete( /*[in]*/ IDispatch *pDisp, /*[in]*/ VARIANT *URL)
{
	if (!g_pAPI)
		return;

	int nTabIndex = m_MDITab.GetTabIndex(m_hWnd);
	g_pAPI->Fire_DocumentComplete( nTabIndex, pDisp, V_BSTR(URL) );
}




/////////////////////////////////////////////////////////////////////////////
// CAPI
HRESULT STDMETHODCALLTYPE CAPI::Advise(IUnknown *pUnk, DWORD *pdwCookie)
{
	HRESULT hr = CProxyIDonutPEvents<CAPI>::Advise(pUnk, pdwCookie);

	if ( SUCCEEDED(hr) ) {
		g_pAPI = this;
		m_aryCookie.Add(pdwCookie);
	}

	//CString str;
	//str.Format("Advise pUnk=%p cookie=%u",pUnk,*pdwCookie);
	//::MessageBox(NULL,str,_T("check"),MB_OK);
	return hr;
}



HRESULT STDMETHODCALLTYPE CAPI::Unadvise(DWORD dwCookie)
{
	HRESULT hr = CProxyIDonutPEvents<CAPI>::Unadvise(dwCookie);

	if ( SUCCEEDED(hr) )
		g_pAPI = NULL;

	//CString str;
	//str.Format("Unadvise cookie=%u",dwCookie);
	//::MessageBox(NULL,_T("unadvise"),_T("check"),MB_OK);
	return hr;
}




/////////////////////////////////////////////////////////////////////////////
///+++ ݂̃ANeBułőI𒆂̃eLXgԂ.
///+++  CSearchBarɗp. { g_pMainWnd-> ̓֐Ăׂ΂A
///+++	  include ̈ˑ֌Wʓ|Ȃ̂...
CString Donut_GetActiveSelectedText()
{
	return g_pMainWnd->GetActiveSelectedText();
}


#if 0
///+++ About_CAOpɃACR[h (ƂłȂƂ>)
HICON Donut_LoadIcon4AboutDialog()
{
	return g_pMainWnd->LoadIcon4AboutDialog();
}
#endif

