/**
 *	@file	DonutPFunc.cpp
 *	@brief	DonutP ̔ėp֐.
 */

#include "stdafx.h"
#include "DonutPFunc.h"
#include "MtlBase.h"
#include "MtlWin.h"
#include "ToolTipManager.h"
#include "resource.h"

using namespace ATL;
using namespace WTL;
using namespace MTL;



extern TCHAR		g_szIniFileName[MAX_PATH];

extern const char	g_cSeparater[]	= _T("");


//+++ gpt@CPȂ̂ŁAւړ.
//x #define PI						3.141592653589793238462643383279
//x #define ANGLE_TO_RADIAN( a )	( (a) * PI / 180.0 )
//x #define RADIAN_TO_ANGLE( a )	( (a) / PI * 180.0 )

static __inline double RADIAN_TO_ANGLE(double a) {
	static const double PI				= 3.141592653589793238462643383279;
	return (a) / PI * 180.0;
}



double _GetAngle(CPoint pt1, CPoint pt2)
{
	double xlen  = pt2.x - pt1.x;
	double ylen  = pt1.y - pt2.y;

	if (fabs( xlen ) < 1.0)
		xlen = 0.0;

	if (fabs( ylen ) < 1.0)
		ylen = 0.0;

	if ( (xlen == 0.0) && (ylen == 0.0) )
		return ( 0.0 );

	if (xlen == 0.0) {
		if (pt1.y < pt2.y)
			return ( 270.0 );
		else
			return (  90.0 );
	} else if (ylen == 0.0) {
		if (pt1.x < pt2.x)
			return (  0.0);
		else
			return (180.0);
	}

	double angle = RADIAN_TO_ANGLE( atan2(ylen, xlen) );

	if (angle < 0.0)
		angle += 360.0;

	return ( angle );
}



BOOL _CheckOsVersion_98Later()
{
	OSVERSIONINFO osi = { sizeof (OSVERSIONINFO) };

	//BOOL bRet =
	::GetVersionEx(&osi);

	//windows98 == 4.10
	return ( (osi.dwMajorVersion >= 5) || (osi.dwMajorVersion == 4 && osi.dwMinorVersion >= 10) );
}



BOOL _CheckOsVersion_MELater()
{
	OSVERSIONINFO osi = { sizeof (OSVERSIONINFO) };

	//BOOL bRet =
	::GetVersionEx(&osi);

	//windowsME == 4.90
	return ( (osi.dwMajorVersion >= 5) || (osi.dwMajorVersion == 4 && osi.dwMinorVersion >= 90) );
}



BOOL _CheckOsVersion_2000Later()
{
	OSVERSIONINFO osi = { sizeof (OSVERSIONINFO) };

	//BOOL bRet =
	::GetVersionEx(&osi);

	//windows2000 5.0
	return ( (osi.dwMajorVersion >= 5) );
}



BOOL _CheckOsVersion_XPLater()
{
	OSVERSIONINFO osi = { sizeof (OSVERSIONINFO) };

	//BOOL bRet =
	::GetVersionEx(&osi);

	//windowsXP 5.1
	return ( (osi.dwMajorVersion == 5) && (osi.dwMinorVersion >= 1) || (osi.dwMajorVersion > 5) );
}



BOOL _CheckOsVersion_VistaLater()
{
	OSVERSIONINFO osi  = { sizeof (OSVERSIONINFO) };

	//BOOL		  bRet =
	::GetVersionEx(&osi);

	//windowsVista 6.0
	return (osi.dwMajorVersion >= 6);
}


#if 1 //+++ ǉ.
/// Wow64(Win64ł32rbg[h)œĂ邩ǂ
BOOL _IsWow64()
{
	typedef BOOL (WINAPI   * LPFN_ISWOW64PROCESS)(HANDLE, PBOOL);
	BOOL				bIsWow64		 = FALSE;
	LPFN_ISWOW64PROCESS fnIsWow64Process = (LPFN_ISWOW64PROCESS)
											::GetProcAddress(GetModuleHandle( TEXT("kernel32") ), "IsWow64Process");
	if (fnIsWow64Process) {
		if ( !fnIsWow64Process(::GetCurrentProcess(), &bIsWow64) ) {
			;	// handle error
		}
	}

	return bIsWow64;
}
#endif



#if 0	//+++ wb_Ɉڂ.
/// undonut.exeƓfBNg strFile ̂ƂătpXԂ.
CString _GetFilePath(const CString& strFile)
{
  #if 1 //+++
	return GetExeDirectory() + strFile;
  #else
	TCHAR	cPathExe[MAX_PATH];

	::GetModuleFileName(_Module.GetModuleInstance(), cPathExe, MAX_PATH);

	CString strPath(cPathExe);

	//#ifdef _DEBUG
	//	strPath = strPath.Left(strPath.ReverseFind('\\'));
	//#endif

	strPath = strPath.Left(strPath.ReverseFind('\\') + 1) + strFile;
	return strPath;
  #endif
}
#endif



/// .exêfBNg̃tpXԂ. Ō'\\'܂.  //+++ _GetDonutPath ϖ
CString GetExeDirectory()
{
  #if 1 //+++
	CString str = GetExeFileName();
	int 	n	= str.ReverseFind( _T('\\') );
	return	str.Left(n + 1);
  #else
	//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
	// pX
	TCHAR	cPathExe[MAX_PATH];
	::GetModuleFileName(_Module.GetModuleInstance(), cPathExe, MAX_PATH);
	CString strFile(cPathExe);
	//#ifdef _DEBUG
	//	strFile = strFile.Left(strFile.ReverseFind('\\'));
	//#endif
	strFile = strFile.Left(strFile.ReverseFind('\\') + 1);
	//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	return strFile;
  #endif
}



#if 0	//+++ gp... (DonutP.INI ďĂ̂)
CString _GetBtnSkinDir()
{
  #if 1
	CString strPath = _GetFilePath( _T("DonutP.INI") );
	CIniFileI	pr( strPath, _T("Path") );
	CString 	strBtnDir = pr.GetString( _T("BtnSkinPath") );
	pr.Close();
	if ( strBtnDir.IsEmpty() ) {
		strBtnDir = GetExeDirectory() + _T("BtnSkin");
	}
	return strBtnDir;
  #else
	CString strPath = _GetFilePath( _T("DonutP.INI") );

	TCHAR	szPath[MAX_PATH];
	memset(szPath, 0, MAX_PATH);

	CString strBtnDir;
	::GetPrivateProfileString(_T("Path"), _T("BtnSkinPath"), _T(""), szPath, MAX_PATH, strPath);
	strBtnDir.Format("%s", szPath);

	if ( strBtnDir.IsEmpty() ) {
		strBtnDir = GetExeDirectory() + _T("BtnSkin");
	}

	return strBtnDir;
  #endif
}
#endif



CString _GetSkinDir()
{
  #if 1
	CString 	strPath  = GetExeDirectory() + _T("Skin\\");
  #else
	CString 	strPath  = MTL::MtlGetModuleFileName();
	strPath 	= strPath.Left(strPath.ReverseFind('\\') + 1);
	strPath    += _T("Skin\\");
  #endif
	CString 	strDefPath = strPath + _T("default");

  #if 1 //+++ ƕobt@̎gp炷.
	CIniFileI	pr( g_szIniFileName, _T("Skin") );
	CString 	strSkinPath = pr.GetString( _T("SkinFolder") );
	pr.Close();

	if ( strSkinPath.IsEmpty() )
		strSkinPath = strDefPath;
	else
		strSkinPath = strPath + strSkinPath;
  #else
	CIniFileI	pr;
	char		buff[MAX_PATH];
	DWORD		dwCount    = MAX_PATH;
	pr.Open( g_szIniFileName, _T("Skin") );
	pr.QueryValue(buff, _T("SkinFolder"), &dwCount);
	pr.Close();

	CString 	strSkinPath;
	strSkinPath = buff;
	if ( strSkinPath.IsEmpty() )
		strSkinPath = strDefPath;
	else
		strSkinPath = strPath + buff;
  #endif

	if (::GetFileAttributes(strSkinPath) == 0xFFFFFFFF) {
		if (GetFileAttributes(strDefPath) == 0xFFFFFFFF) {
			strSkinPath = strPath;
		} else {
			strSkinPath = strDefPath;
		}
	}

	if ( !strSkinPath.IsEmpty() && strSkinPath.Right(1) != _T("\\") )
		strSkinPath += _T("\\");

	return strSkinPath;
}



CString _GetRecentCloseFile()
{
	return _GetFilePath("RecentClose.ini");
}



bool _LoadToolTipText(int nCmdID, CString &strText)
{
	enum { SIZE = 1024/*256*/ };
	TCHAR	szBuff[SIZE+2];
	szBuff[0] = 0;
	int   nRet = ::LoadString(_Module.GetResourceInstance(), nCmdID, szBuff, SIZE);

	for (int i = 0; i < nRet; i++) {
		if ( szBuff[i] == _T('\n') ) {
			TCHAR	szText[SIZE];
			lstrcpyn(szText, &szBuff[i + 1], SIZE);
			strText = szText;
			return true;
		}
	}

	return false;
}



/*
	CString GetJapanAt(CString str, int nIndex)
	{
	//don't use
	int nlen=0;
	for (int ii=0;ii<str.GetLength();)
	{
		if (nlen==nIndex)
			break;
		if (_ismbblead(str[ii]))
			ii++;
		ii++;
		nlen++;
	}

	int nlenm=1;
	if (_ismbblead(str[ii]))
		nlenm=2;

	return str.Mid(ii,nlenm);

	}
 */


#if 0
//	#define SJIS1_S1	0x81
//	#define SJIS1_E1	0x9f
//	#define SJIS1_S2	0xe0
//	#define SJIS1_E2	0xf5
//
//	//SJIS
//	BOOL IsSJISLeadByte(BYTE c)
//	{
//	  #ifdef _UNICODE
//		ATLASSERT(FALSE);
//	  #endif
//		//œK͖ʓ|Ȃ̂łȂ
//		if ( (SJIS1_S1 <= c && c <= SJIS1_E1) || (SJIS1_S2 <= c && c <= SJIS1_E2) )
//			return TRUE;
//		return FALSE;
//	}
#endif



// 1i߁Ai߂oCgԂBANULL̂Ƃ̓|C^i߂A0Ԃ
int RtlMbbNext(LPTSTR &r_lp)
{
	LPCTSTR lpBegin = r_lp;

	if (r_lp) {
		++r_lp;
		if ( _ismbblead( *(r_lp - 1) ) && _ismbbtrail(*r_lp) ) {
			// 2oCg̎͂1oCgi߂
			++r_lp;
		}
	}

	return int (r_lp - lpBegin);
}



// strText  nFirst ڂAnCount 擾ĕԂB}`oCgΉ
CString RtlMbbStrMid(CString strText, const int &nFirst, const int &nCount)
{
	ATLASSERT( nFirst >= 0 );

	if (nCount < 1 || strText.GetLength() <= nFirst)
		return CString();

	LPTSTR lp = strText.GetBuffer(0);
	int    i, p1 = 0, p2 = 0;

	for (i = 0; *lp && p1 < nFirst; ++i) {
		p1 += RtlMbbNext(lp);
	}

	for (i = 0; *lp && p2 < nCount; ++i) {
		p2 += RtlMbbNext(lp);
	}

	strText.ReleaseBuffer();
	return strText.Mid(p1, p2);
}


/*+++ :
	Xp(rWAX^C)Manifestt@CgpꍇAANSIłEditRg[֌W
	EM_GETSEL,EM_SETSEL,EM_LIMITTEXT ŁAȑOWinOSł̓oCgŎw肵Ă̂A
	PʂɂĂ܂炵B(̓ Unicode  API Ɠl̓炵)
		http://support.microsoft.com/default.aspx?scid=kb;ja;418099
			WindowsXP  Manifest t@CgpAvP[V Common Control
			o[W 6 gpꍇAEdit Rg[ւ EM_LIMITTEXT bZ[W
			ɂ͗ʐݒ肷ۂ̒PʂAoCgPʂł͂ȂPʂɕύX
			܂B͎̓dlłB

	ccManifestt@CgpĂ̂́Agݍmanifest̏ꍇ͓Ă͂܂ȂA
	ƂȂ̂? vistaxpłʏ̓oCgԂ. L[`ł́A.manifest
	t@C̑݃`FbNŉ߂؂ւĂ̂...
 */



CString RtlGetSelectedText(const CEdit &edit)
{
	CString str    = MtlGetWindowText(edit);

	if ( str.IsEmpty() )
		return CString();

	int 	nStart = -1;
	int 	nEnd   = -1;
	edit.GetSel(nStart, nEnd);									// I͈͂uvŕԂ

	if ( nStart != nEnd && str.GetLength() != (nEnd - nStart) && !(nStart == 0 && nEnd == -1) ) {
		str = RtlMbbStrMid(str, nStart, nEnd - nStart); 		// oCgɕϊKv
	}

	return str;
}



/// EM_GETSELVisualStyleKpUNICODEI(UNICODE`Ȃꍇł)̂łȂƂ֐
CString _GetSelectTextWtoA(CEdit &edit)
{
	int 	nStart = -1;
	int 	nEnd   = -1;
	edit.GetSel(nStart, nEnd);									// I͈͂uvŕԂ

	//UNICODEł̒l()
	if (nStart == nEnd)
		return MtlGetWindowText(edit);							// +++ :͈͎w肪Ȃꍇ́AŜԂ.

	int 	nTextLen  = ::GetWindowTextLength(edit.m_hWnd);
	int 	nSelCount = nEnd - nStart;

	LPTSTR	lpAll	  = new CHAR [nTextLen	+ 1];
	LPWSTR	lpwAll	  = new WCHAR[nTextLen	+ 1];
	LPWSTR	lpwSel	  = new WCHAR[nSelCount + 1];

	::GetWindowText(edit.m_hWnd, (LPTSTR) lpAll, nTextLen + 1); 		//ANSIȃeLXgԂ
	::MultiByteToWideChar(CP_ACP, 0, lpAll, -1, lpwAll, nTextLen + 1);	// +++ : U UTF16ɂ

	memset( lpwSel, 0, (nSelCount + 1) * sizeof (WCHAR) );
	CopyMemory( lpwSel, lpwAll + nStart, nSelCount * sizeof (WCHAR) );	// +++ :

	CString str 	  = lpwSel; 		// +++ :̃Rs[RXgN^ UTF16 MBC ɕϊ.

	delete[] lpAll;
	delete[] lpwAll;
	delete[] lpwSel;
	return str;
}



CString _GetSelectText(CEdit &edit)
{
	//VisualStyle KpĂꍇ EM_GETSEL  UNICODE ŕԂ
	CString 	str;

	// +++ :Xpȍ~WinOS ŁAexeƓtH_ .manifestt@Cꍇ.
	//			 exet@CƓƂɂ.manifestt@CāAQ΍悤Ȃ̂.
	//x if ( CThemeDLLLoader::IsExistManifest() && _CheckOsVersion_XPLater() )	//+++ CThemeDLLLoader gȂ悤ɂ.
	if ( IsExistManifestFile() && _CheckOsVersion_XPLater() ) {
		//UNICODEANSI֕ϊ
		str = _GetSelectTextWtoA(edit);
	} else {
		//ANSȈꍇRAPT̃R[h𗬗p
		str = RtlGetSelectedText(edit);
	}

	return str;
}



//+++ Ƃō蒼.
static CString GetCurPosWord(const char* buf, unsigned len, unsigned pos);
static CString GetCurPosWordB(const char* buf, unsigned len, unsigned pos);

///*+++ i: GetSel̕Ԃl̈KȂ̂ŁA듮(ႤP)肦.
///+++ GfBbǵAIeLXg̎擾. Ȉꍇ́AJ[\ʒu̒P擾.(y[Wp)
CString _GetSelectText_OnCursor(CEdit &edit)
{
	int 	len = ::GetWindowTextLength( edit.m_hWnd ); 	// oCg.
	int 	nStart = -1, nEnd = -1;
	edit.GetSel(nStart, nEnd);								// I͈͂Ԃ(oCg󋵂̂悤)

	if (len == 0 || nStart != nEnd || nStart < 0)			// ͈͎w肾AȂwȏԂȂ猳̏܂.
		return _GetSelectText( edit );

	std::vector<char>	buf( len + 2 );
	::GetWindowText(edit.m_hWnd, (LPTSTR)&buf[0], len + 1); // 擾.
	// +++ :Xpȍ~WinOS ŁAexeƓtH_ .manifestt@Cꍇ.
	if ( IsExistManifestFile() && _CheckOsVersion_XPLater() ) {
		return GetCurPosWord( &buf[0], len, nStart );			// P擾. nStart.
	} else {
		for (int i = 0; i < len; ++i) { 						// Sp󔒂͔pQɒu.
			unsigned c = *(unsigned char*)&buf[i];
			if (c == 0x81 && buf[i+1] == 0x40) {
				buf[i  ]  = ' ';
				buf[++i]  = ' ';
			}
		}
		return GetCurPosWordB( &buf[0], len, nStart );			// P擾. nStartoCg.
	}
}



///+++ pos̈ʒu()ɂ󔒂ŋ؂ꂽP CStringɂĕԂ. '"'͖l.
static CString GetCurPosWord(const char* src, unsigned len, unsigned pos)
{
	#define IS_SPACE_W(c)		((c) == L' ' || (c) == L'\t' || (c) == L'\n' || (c) == L'\r' || (c) == L'@')
	ATLASSERT(src != 0 && len > 0 && pos <= len);
	std::vector<WCHAR>	wbuf( len + 2 );
	::MultiByteToWideChar(CP_ACP, 0, &src[0], -1, &wbuf[0], len + 1);	// Uwchar.

	unsigned	top = 0;
	unsigned	end = len;

  #if 0 	// ܂AJ[\ʒuɕ邩`FbN. 󔒂ȂAO̒P̍Ōֈړ.
	unsigned c = wbuf[ pos ];
	if (c == 0)
		return CString( src );
	if (IS_SPACE_W(c)) {
		if (pos > 0) {
			do {
				c = wbuf[--pos];
			} while (pos > top && IS_SPACE_W(c));
		}
		if (IS_SPACE_W(c)) {	// J[\OɒPꂪȂȂAɈړ.
			do {
				c = wbuf[++pos];
			} while (pos < end && IS_SPACE_W(c));
		}
	}
  #else 	// ܂AJ[\ʒuɕ邩`FbN. 󔒂ȂA̒P̐擪ֈړ.
	unsigned c = wbuf[ pos ];
	if (IS_SPACE_W(c)) {
		do {
			c = wbuf[++pos];
		} while (pos < end && IS_SPACE_W(c));
	}
	if (c == 0)
		return CString( src );
  #endif

	// J[\ʒuP̐擪T.
	for (int i = int(pos); --i >= 0;) {
		c = wbuf[i];
		if (IS_SPACE_W(c) || c == 0) {
			top = i;
			break;
		}
	}

	// J[\ʒuP̍ŌT.
	for (unsigned i = pos; i < end; ++i) {
		c = wbuf[i];
		if (IS_SPACE_W(c) || c == 0) {
			end = i;
			break;
		}
	}

	// I[ݒ.
	wbuf[end] = 0;

	if (top >= end) { // ŜԂ.
		return CString( src );
	} else {
		return CString ( &wbuf[top] );	// topend܂łwcharCString(Rs[RXgN^ɔC)
	}

	#undef IS_SPACE_W
}



///+++ pos̈ʒu(oCg)ɂ󔒂ŋ؂ꂽP CStringɂĕԂ. '"'͖l.
/// Ƃ肠Aʓ|ȂŁASp󔒖Ή.\ł炩ߒu悤ɂ.(wxp͂܂...)
static CString GetCurPosWordB(const char* src, unsigned len, unsigned pos)
{
	#define IS_SPACE(c) 	((c) == ' ' || (c) == '\t' || (c) == '\n' || (c) == '\r')
	ATLASSERT(src != 0 && len > 0 && pos <= len);
	std::vector<char>		bbuf(len + 4);
	memcpy(&bbuf[0], src, len+1);
	unsigned	top = 0;
	unsigned	end = len;

  #if 0 	// ܂AJ[\ʒuɕ邩`FbN. 󔒂ȂAO̒P̍Ōֈړ.
	unsigned c = bbuf[ pos ];
	if (c == 0)
		return CString( src );
	if (IS_SPACE(c) || c == 0) {
		if (pos > 0) {
			do {
				c = bbuf[--pos];
			} while (pos > top && IS_SPACE(c));
		}
		if (IS_SPACE(c)) {	// J[\OɒPꂪȂȂAɈړ.
			do {
				c = bbuf[++pos];
			} while (pos < end && IS_SPACE(c));
		}
	}
  #else 	// ܂AJ[\ʒuɕ邩`FbN. 󔒂ȂA̒P̐擪ֈړ.
	unsigned c = bbuf[ pos ];
	if (IS_SPACE(c)) {
		do {
			c = bbuf[++pos];
		} while (pos < end && IS_SPACE(c));
	}
	if (c == 0)
		return CString( src );
  #endif

	// J[\ʒuP̐擪T.
	for (int i = int(pos); --i >= 0;) {
		c = bbuf[i];
		if (IS_SPACE(c) || c == 0) {
			top = i;
			break;
		}
	}

	// J[\ʒuP̍ŌT.
	for (unsigned i = pos; i < end; ++i) {
		c = bbuf[i];
		if (IS_SPACE(c) || c == 0) {
			end = i;
			break;
		}
	}

	// I[ݒ.
	bbuf[end] = 0;

	if (top >= end) { // ŜԂ.
		return CString( src );
	} else {
		return CString ( &bbuf[top] );	// topend܂łwcharCString(Rs[RXgN^ɔC)
	}

	#undef IS_SPACE
}



BOOL _AddSimpleReBarBandCtrl(
		HWND	hWndReBar,
		HWND	hWndBand,
		int 	nID,
		LPTSTR	lpstrTitle,
		BOOL	bNewRow,
		int 	cxWidth,
		BOOL	bFullWidthAlways)
{
	ATLASSERT( ::IsWindow(hWndReBar) ); 	// must be already created
  #ifdef _DEBUG
	// block - check if this is really a rebar
	{
		TCHAR lpszClassName[sizeof (REBARCLASSNAME)];
		::GetClassName( hWndReBar, lpszClassName, sizeof (REBARCLASSNAME) );
		ATLASSERT(lstrcmp(lpszClassName, REBARCLASSNAME) == 0);
	}
  #endif	//_DEBUG
	ATLASSERT( ::IsWindow(hWndBand) );		// must be already created

	// Get number of buttons on the toolbar
	int 		  nBtnCount = (int) ::SendMessage(hWndBand, TB_BUTTONCOUNT, 0, 0L);
	// Set band info structure
	REBARBANDINFO rbBand;
	rbBand.cbSize	 = sizeof (REBARBANDINFO);
  #if (_WIN32_IE >= 0x0400)
	rbBand.fMask	 = RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE | RBBIM_ID | RBBIM_SIZE | RBBIM_IDEALSIZE;
  #else
	rbBand.fMask	 = RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE | RBBIM_ID | RBBIM_SIZE;
  #endif	//!(_WIN32_IE >= 0x0400)
	if (lpstrTitle != NULL)
		rbBand.fMask |= RBBIM_TEXT;

	rbBand.fStyle	 = 0;
  #if (_WIN32_IE >= 0x0500)
	if (nBtnCount > 0)											// add chevron style for toolbar with buttons
		rbBand.fStyle |= RBBS_USECHEVRON;
  #endif	//(_WIN32_IE >= 0x0500)

	if (bNewRow)
		rbBand.fStyle |= RBBS_BREAK;

	rbBand.lpText	 = lpstrTitle;
	rbBand.hwndChild = hWndBand;

	if (nID == 0)	// calc band ID
		nID = ATL_IDW_BAND_FIRST + (int) ::SendMessage(hWndReBar, RB_GETBANDCOUNT, 0, 0L);

	rbBand.wID		 = nID;

	// Calculate the size of the band
	BOOL	bRet;
	RECT	rcTmp;

	if (nBtnCount > 0) {
		bRet			  = ::SendMessage(hWndBand, TB_GETITEMRECT, nBtnCount - 1, (LPARAM) &rcTmp) != 0;
		ATLASSERT(bRet);
		rbBand.cx		  = (cxWidth != 0) ? cxWidth : rcTmp.right;
		rbBand.cyMinChild = rcTmp.bottom - rcTmp.top;
		rbBand.cxMinChild = 0;
		/*			if(bFullWidthAlways)
				{
					rbBand.cxMinChild = rbBand.cx;
				}
				else if(lpstrTitle == 0)
				{
					bRet = (BOOL)::SendMessage(hWndBand, TB_GETITEMRECT, 0, (LPARAM)&rcTmp);
					ATLASSERT(bRet);
					rbBand.cxMinChild = rcTmp.right;
				}
				else
				{
					rbBand.cxMinChild = 0;
				}
		 */
	} else {	// no buttons, either not a toolbar or really has no buttons
		bRet			  = ::GetWindowRect(hWndBand, &rcTmp) != 0;
		ATLASSERT(bRet);
		rbBand.cx		  = (cxWidth != 0) ? cxWidth : (rcTmp.right - rcTmp.left);
		rbBand.cxMinChild = (bFullWidthAlways) ? rbBand.cx : 0;
		rbBand.cyMinChild = rcTmp.bottom - rcTmp.top;
	}

  #if (_WIN32_IE >= 0x0400)
	rbBand.cxIdeal = rbBand.cx;
  #endif	//(_WIN32_IE >= 0x0400)

	// Add the band
	LRESULT lRes = ::SendMessage(hWndReBar, RB_INSERTBAND, (WPARAM) -1, (LPARAM) &rbBand);

	if (lRes == 0) {
		ATLTRACE2( atlTraceUI, 0, _T("Failed to add a band to the rebar.\n") );
		return FALSE;
	}

	return TRUE;
}



bool FileWriteString(const CString& strFile, std::list<CString>*pString)
{
	FILE *	fp;
	if ( ( fp = fopen(strFile, "w") ) == NULL ) {
		return false;
	}

	std::list<CString>::iterator str;
	CString 					 strOut;

	for (str = pString->begin(); str != pString->end(); ++str) {
		fprintf(fp, "%s\n", *str);
	}

	fclose(fp);

	return true;
}



bool FileReadString(const CString& strFile, std::list<CString>*pString)
{
	FILE *	fp;

	if ( ( fp = fopen(strFile, "r") ) == NULL ) {
		return false;
	}

	char	cBuff[4096];
	int 	nLen = 0;
	CString strBuff;

	while (fgets(cBuff, 4096, fp) != NULL) {
		nLen = lstrlen(cBuff);

		if (nLen != 0 && cBuff[nLen - 1] == '\n')
			cBuff[nLen - 1] = '\0';

		pString->insert(pString->end(), cBuff);
	}

	fclose(fp);

	return true;
}



BOOL _SetCombboxCategory(CComboBox &cmb, HMENU hMenu)
{
	if (cmb.m_hWnd == NULL)
		return FALSE;

	if (cmb.GetCount() != 0)
		return FALSE;

	for (int ii = 0; ii < ::GetMenuItemCount(hMenu); ii++) {
		char cBuff[MAX_PATH];

		if (::GetMenuString(hMenu, ii, cBuff, MAX_PATH, MF_BYPOSITION) == 0)
			continue;

		CString strMenu(cBuff);

		if (strMenu.Find("(") != -1)
			strMenu = strMenu.Left( strMenu.Find("(") );
		else if (strMenu.Find("\t") != -1)
			strMenu = strMenu.Left( strMenu.Find("\t") );

		cmb.AddString(strMenu);
	}

	cmb.SetCurSel(0);
	return TRUE;
}



BOOL _DontUseID(UINT uID)
{
	// UINT uDontUseID[] = {ID_FILE_MRU_FILE1, ID_INSERTPOINT_GROUPMENU, ID_INSERTPOINT_FAVORITEMENU};
	static const UINT uDontUseID[] = { ID_INSERTPOINT_GROUPMENU, ID_INSERTPOINT_FAVORITEMENU };

	for (int ii = 0; ii < sizeof (uDontUseID) / sizeof (UINT); ii++) {
		if (uID == uDontUseID[ii])
			return TRUE;
	}

	return FALSE;
}



void _PickUpCommandSub(HMENU hMenuSub, CComboBox &cmbCmd)
{
	CMenu	menuSub(hMenuSub);
	int nPopStartIndex = cmbCmd.AddString(g_cSeparater);
	int nAddCnt 	   = 0;

	for (int ii = 0; ii < menuSub.GetMenuItemCount(); ii++) {
		HMENU	hMenuSub2 = menuSub.GetSubMenu(ii);

		if (hMenuSub2)
			_PickUpCommandSub(hMenuSub2, cmbCmd);

		UINT	nCmdID	  = menuSub.GetMenuItemID(ii);

		if ( _DontUseID(nCmdID) )
			break;

		CString strMenu;
		CToolTipManager::LoadToolTipText(nCmdID, strMenu);

		if ( strMenu.IsEmpty() )
			continue;

		int 	nIndex	  = cmbCmd.AddString(strMenu);
		cmbCmd.SetItemData(nIndex, nCmdID);
		nAddCnt++;
	}

	if (nAddCnt != 0)
		cmbCmd.AddString(g_cSeparater);
	else
		cmbCmd.DeleteString(nPopStartIndex);

	menuSub.Detach();
}



void _PickUpCommand(HMENU hMenu, int nPopup, CComboBox &cmbCmd)
{
	HMENU	hMenuSub = ::GetSubMenu(hMenu, nPopup);
	CMenu	menu(hMenuSub);
	cmbCmd.ResetContent();

	for (int ii = 0; ii < ::GetMenuItemCount(hMenuSub); ii++) {
		HMENU	hMenuSub = menu.GetSubMenu(ii);

		if (hMenuSub)
			_PickUpCommandSub(hMenuSub, cmbCmd);

		UINT	nCmdID	 = menu.GetMenuItemID(ii);

		if ( _DontUseID(nCmdID) )
			break;

		CString strMenu;
		CToolTipManager::LoadToolTipText(nCmdID, strMenu);

		if ( strMenu.IsEmpty() )
			continue;

		int 	nIndex	 = cmbCmd.AddString(strMenu);
		cmbCmd.SetItemData(nIndex, nCmdID);
	}

	menu.Detach();

	//svȃZp[^̍폜
	int   nCountSep = 0;
	int   nCountCmb = cmbCmd.GetCount();

	for (int i = 0; i < nCountCmb - 1; i++) {
		if (cmbCmd.GetItemData(i) == 0) {
			nCountSep++;

			if (cmbCmd.GetItemData(i + 1) == 0) {
				cmbCmd.DeleteString(i);
				nCountCmb--;
				i--;
			}
		}
	}

	if (nCountSep > 2) {
		if (cmbCmd.GetItemData(0) == 0)
			cmbCmd.DeleteString(0);

		int nIndexLast = cmbCmd.GetCount() - 1;

		if (cmbCmd.GetItemData(nIndexLast) == 0)
			cmbCmd.DeleteString(nIndexLast);
	}
}



//minit
BOOL _ReplaceImageList(CString strBmpFile, CImageList &imgs, DWORD dfltRes)
{
	CBitmap 	bmp;
	bmp.Attach( AtlLoadBitmapImage(strBmpFile.GetBuffer(0), LR_LOADFROMFILE) );
  #if 0 //+++
	return _ReplaceImageList(bmp.m_hBitmap, imgs);
  #else
	if (bmp.m_hBitmap == 0 && dfltRes) {
		bmp.LoadBitmap(dfltRes);	//+++	t@CȂƂAftHg̃\[Xǂݍł݂.
	}
	if (bmp.m_hBitmap) {
		int nCount = imgs.GetImageCount();
		for (int i = 0; i < nCount; i++) {
			if ( !imgs.Remove(0) )
				return FALSE;
		}
		imgs.Add( bmp, RGB(255, 0, 255) );
		return TRUE;
	}
	return FALSE;
  #endif
}


#if 0	//+++ t@CłŃftHgwł悤ɂ̂ŕsv.
///+++
BOOL _ReplaceImageList(HBITMAP hBitmap, CImageList &imgs)
{
	if (hBitmap == 0)
		return FALSE;
	int nCount = imgs.GetImageCount();
	for (int i = 0; i < nCount; i++) {
		if ( !imgs.Remove(0) )
			return FALSE;
	}
	CBitmapHandle	bmp( hBitmap );
	imgs.Add( bmp, RGB(255, 0, 255) );
	return TRUE;
}
#endif



static int _Pack(int hi, int low)
{
	if ( !( ( ('0' <= low && low <= '9') || ('A' <= low && low <= 'F') || ('a' <= low && low <= 'f') )
		  && ( ('0' <= hi && hi  <= '9') || ('A' <= hi	&& hi  <= 'F') || ('a' <= hi  && hi  <= 'f') ) ) )
		return 0;	//lł͂Ȃ

	int nlow = ('0' <= low && low <= '9') ? low - '0'
			 : ('A' <= low && low <= 'F') ? low - 'A' + 0xA
			 :								low - 'a' + 0xA ;
	int nhi  = ('0' <= hi  && hi  <= '9') ? hi	- '0'
			 : ('A' <= hi  && hi  <= 'F') ? hi	- 'A' + 0xA
			 :								hi	- 'a' + 0xA ;

	return (nhi << 4) + nlow;
}



BOOL _QueryColorString(CIniFileI &pr, COLORREF &col, LPCTSTR lpstrKey)
{
  #if 1 //+++ Lq̌yʉ.
	CString strCol = pr.GetString(lpstrKey, NULL, 20);
	//+++ X pr.QueryValue()ł̃G[́A0̎̂ƂȂ̂ŁA񂪋󂩂ǂ̃`FbNŏ\.
	if ( strCol.IsEmpty() )
		return FALSE;
  #else
	CString strCol;
	DWORD	dwBufferSize = 20;
	DWORD	dwLen		 = dwBufferSize;
	LONG	lRet		 = pr.QueryValue(strCol.GetBuffer(dwBufferSize), lpstrKey, &dwLen);
	strCol.ReleaseBuffer();
	if (lRet != ERROR_SUCCESS)
		return FALSE;

	if ( strCol.IsEmpty() )
		return FALSE;
  #endif

	strCol.TrimLeft('#');

	col = RGB( _Pack(strCol[0], strCol[1]) ,
			   _Pack(strCol[2], strCol[3]) ,
			   _Pack(strCol[4], strCol[5])
			 );

	return TRUE;
}



// ===========================================================================
//+++ +modǉ	(t@Cnamespacepӂق悢... ̂)


#if 1
///+++ undonut.exẽtpXԂ.  (MtlGetModuleFileNameƈꏏ...)
CString 	GetExeFileName()
{
	TCHAR	buf[MAX_PATH];
	buf[0] = 0;
	::GetModuleFileName(_Module.GetModuleInstance(), buf, MAX_PATH);
	return CString(buf);
}
#endif



//+++ .manifest̑݃`FbN	 CThemeDLLLoader Ɨ & ƃl[
bool IsExistManifestFile()
{
  #if 1
	CString 	strFile = GetExeFileName() + _T(".manifest");
	return (::GetFileAttributes(strFile) != 0xFFFFFFFF);
  #else
	TCHAR		sz[MAX_PATH];
	::GetModuleFileName(_Module.GetModuleInstance(), sz, MAX_PATH);
	CString 	strFile(sz);
	strFile += _T(".manifest");
	return (::GetFileAttributes(strFile) != 0xFFFFFFFF) ? TRUE : FALSE;
  #endif
}



//+++	strFile .bak t@Cɕϖ. Â .bak ΂͍폜.
void	MoveToBackupFile(const CString& strFileName)
{
	CString 	strBakName = strFileName + ".bak";
	if (::GetFileAttributes(strBakName) != 0xFFFFFFFF)
		::DeleteFile(strBakName);					// ÂobNAbvt@C폜.
	if (::GetFileAttributes(strFileName) != 0xFFFFFFFF)
		::MoveFile(strFileName, strBakName);		// ̃t@CobNAbvt@Cɂ.
}



//+++ JgfBNg̎擾.
const CString GetCurDirectory()
{
	TCHAR dir[MAX_PATH+2];
	dir[0] = 0;
	::GetCurrentDirectory(MAX_PATH, dir);
	return CString(dir);
}



int SetCurDirectory(const CString& strDir)
{
	return ::SetCurrentDirectory(LPCTSTR(strDir));
}



//+++ t@CpXAfBNg擾. Ō'\\'͊܂܂Ȃ.
const CString	GetDirName(const CString& strFileName)
{
	int 	n	= strFileName.ReverseFind( _T('\\') );
	if (n < 0)
		return strFileName;
	return	strFileName.Left(n);
}


//+++ t@CpXAt@C擾
const CString	GetFileBaseName(const CString& strFileName)
{
	int 	n	= strFileName.ReverseFind( _T('\\') );
	if (n < 0)
		return strFileName;
	return	strFileName.Mid(n + 1);
}


///+++ t@C̊gq̎擾.  ʂ̕ɂ'.'͊܂܂Ȃ.
const CString	GetFileExt(const CString& strFileName)
{
	const CString strBaseName = GetFileBaseName(strFileName);
	int 	n	= strBaseName.ReverseFind( _T('.') );
	if (n < 0)
		return CString();
	return strFileName.Mid(n + 1);
}



///+++ 蔲ȃtpX. fBNg̎w肪Ȃ΁AundonuttH_ƂȂ.
const CString GetFullPath_ForExe(const CString& strFileName)
{
	const BYTE* p = (const BYTE*) LPCTSTR(strFileName);
	if (p == 0 || *p == 0) {
		return GetExeDirectory();
	}
	unsigned	c  = *p;
	unsigned	c1 = p[1];
	unsigned	c2 = 0;
	if (c == '\\' || c == '/' || (c1 == ':' && ((c2 = p[2]) == '\\' || c2 == '/')) ) {
		return strFileName; // tpX낤ł̂܂ܕԂ.
	} else if (c1 == ':' || (c == '.' && (c1 == '\\' || c1 == '/' || (c1 == '.' && ((c2 = p[2]) == '\\' || c2 == '/'))) ) ) {
		// ΃pXۂAʏ̃tpXĂ... 蔲ŃJg𒲐.
		CString sav = GetCurDirectory();
		SetCurDirectory( GetExeDirectory() );
		char	buf[ MAX_PATH + 4 ];
		_fullpath(buf, strFileName, MAX_PATH);
		SetCurDirectory( sav );
		return CString(buf);
	} else {	// łȂꍇundonut̃tH_̎wƂĈ.
		return GetExeDirectory() + strFileName;
	}
}



///+++ 󔒂ŋ؂ꂽŏ̕Ԃ.
const CString GetStrWord(const TCHAR* str, const TCHAR** ppNext)
{
	#define IS_SPACE(c) 	(0 <  (c) && (c) <= _T(' '))
	#define IS_SPACE_EOS(c) (0 <= (c) && (c) <= _T(' '))
	const TCHAR*	p = (const TCHAR*)str;
	int 			c;
	do {
		c = *p++;
	} while (IS_SPACE(c));
	--p;
	const TCHAR*	bgn = p;
	do {
		c = *p++;
	} while (IS_SPACE_EOS(c) == 0);
	--p;
	const TCHAR*	end = p;
	if (ppNext)
		*ppNext = p;
	size_t l = end - bgn;
	return CString(bgn, l);
	#undef IS_SPACE
	#undef IS_SPACE_EOS
}



///+++ 󔒂ŋ؂ꂽP𕪉
void SeptTextToWords(std::vector<CString>& strs, const TCHAR* line)
{
	const TCHAR*	p = line;
	while (*p) {
		CString str = GetStrWord(p, &p);
		if (str.IsEmpty())
			break;
		strs.push_back(str);
	}
}


///+++ sŕ. (s͖)
void SeptTextToLines(std::vector<CString>& strs, const TCHAR* text)
{
	const TCHAR*	t = text;
	const TCHAR*	p = t;
	for (;;) {
		int c = *p++;
		if (c == '\r' || c == '\n' || c == '\0') {
			ptrdiff_t l = p - t - 1;
			if (l > 0)
				strs.push_back(CString(t, l));
			if (c == 0)
				break;
			if (c == '\r' && *p == '\n')
				++p;
			t = p;
		}
	}
}


///+++ t@CpX̋L_ɕςOɂĕԂ. VtgJIŜ܂܂Ԃׂ. Mutex̃L[̂߂ɗp.
const CString ConvPathNameToAlNumName(const TCHAR* src)
{
  #if 1 //+++ VtgJISO.
	CString dst( src );
	unsigned l = dst.GetLength();
	for (unsigned i = 0; i < l; ++i) {
		unsigned c = dst.GetAt(i);
		if ( isalnum((unsigned char)c) || c == _T('_') ) {
			;
		} else {
			dst.SetAt(i, _T('_'));
		}
	}
	return dst;
  #else
	CString dst( src );
	dst.Replace( _T('\\'), _T('_') );
	dst.Replace( _T('/' ), _T('_') );
	dst.Replace( _T(':' ), _T('_') );
	dst.Replace( _T(',' ), _T('_') );
	dst.Replace( _T('.' ), _T('_') );
	dst.Replace( _T(';' ), _T('_') );
	dst.Replace( _T('"' ), _T('_') );
	dst.Replace( _T('\''), _T('_') );
	dst.Replace( _T('<' ), _T('_') );
	dst.Replace( _T('>' ), _T('_') );
	dst.Replace( _T('(' ), _T('_') );
	dst.Replace( _T(')' ), _T('_') );
	dst.Replace( _T('|' ), _T('_') );
	dst.Replace( _T('*' ), _T('_') );
	dst.Replace( _T('?' ), _T('_') );
	dst.Replace( _T(' ' ), _T('_') );
	return dst;
  #endif
}



#include <stdarg.h>

//+++ G[Oo.
void ErrorLogPrintf(const char* fmt, ...)
{
	FILE* fp = fopen("errorlog.txt", "a");
	if (fp) {
		va_list app;
		va_start(app, fmt);
		vfprintf(fp, fmt, app);
		va_end(app);
		fclose(fp);
	}
}



#if 1	//+++ IɁȀŃbZ[W΂...
#include "dbg_wm.h"
int ForceMessageLoop(HWND hWnd)
{
	MSG msg = {0};
	int ret;
	int n = 0;
wm_t wm;
	CMessageLoop *pLoop 	 = _Module.GetMessageLoop();
	while ((ret = ::PeekMessage(&msg, hWnd, 0, 0, PM_NOREMOVE)) != 0) {
wm = (wm_t)msg.message;
		//if (ret < 0)
		//	break;
		if (!GetMessage (&msg,hWnd,0,0))	/* bZ[W. QUITAU*/
			return 0;	//x return msg.wParam ;
		if(pLoop->PreTranslateMessage(&msg) == 0)
		{
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
		++n;
	}
	pLoop->OnIdle(1);
#if 0
::WaitMessage();
#endif
	return 1;
}
#endif



#if 0
#include "option/SkinOption.h"

///+++ LvV̎Ac[o[̌Ԃ߂悤ɂ邽߂ɁALvV͂񂾃t֐.
bool  Donut_FakeCaptionLButtonDown(HWND hWnd, HWND hWndTopLevelParent, LPARAM lParam)
{
	if (CSkinOption::s_nMainFrameCaption == 0) {
	  #if 1 //+++ j[̂CɓoāA̍ڂړ悤Ƃ瑋ړĂ܂̂ŁȂ΍
		CRect	rc;
		::GetWindowRect(hWnd, rc);
		POINT	pt;
		::GetCursorPos(&pt);
		if (rc.PtInRect(pt))
	  #endif
		{
			//HWND	hWndTopLevelParent = GetTopLevelWindow();
			::PostMessage(hWndTopLevelParent, WM_NCLBUTTONDOWN, HTCAPTION, lParam);
			return true;
		}
	}
	return false;
}
#endif



#include "MtlProfile.h"
int GetFontHeight(HFONT hFont)
{
	MTL::CLogFont	lf;
	CFontHandle( hFont ).GetLogFont(&lf);
	int 	h	= lf.lfHeight;
	if (h < 0)
		h = -h;
	return h;
}




// ===========================================================================

//+++	ATL3nŃRpCł悤ɂ邽߂̃bp[֐
HRESULT 	RegKey_QueryStringValue(CRegKey& rk, const TCHAR* key, TCHAR* dst, DWORD* pCount)
{
  #if _ATL_VER >= 0x700
	return rk.QueryStringValue(key, dst, pCount);
  #else
	return rk.QueryValue(dst, key, pCount);
  #endif
}


//+++	ATL3nŃRpCł悤ɂ邽߂̃bp[֐
HRESULT 	RegKey_SetStringValue(CRegKey& rk, const TCHAR* value, const TCHAR* key)
{
  #if _ATL_VER >= 0x700
	return rk.SetStringValue(value, key);
  #else
	return rk.SetValue(value ? value : "", key);
  #endif
}


//+++	ATL3nŃRpCł悤ɂ邽߂̃bp[֐
HRESULT 	RegKey_QueryDWORDValue(CRegKey& rk, const TCHAR* key, DWORD& value)
{
  #if _ATL_VER >= 0x700
	return rk.QueryDWORDValue(key, value);
  #else
	return rk.QueryValue(value, key);
  #endif
}


//+++	ATL3nŃRpCł悤ɂ邽߂̃bp[֐
HRESULT 	RegKey_SetDWORDValue(CRegKey& rk, const TCHAR* key, DWORD value)
{
  #if _ATL_VER >= 0x700
	return rk.SetDWORDValue(key, value);
  #else
	return rk.SetValue(value, key);
  #endif
}

