/**
 *	@file	SkinOpiton.cpp
 *	@brief	donut̃IvV : XL
 */

#include "stdafx.h"
#include "SkinOption.h"
#include "../DonutPFunc.h"
#include "../DonutDefine.h"

using namespace MTL;



////////////////////////////////////////////////////////////////////////////////
//CSkinPropertyPage̒`
////////////////////////////////////////////////////////////////////////////////

int 	CSkinOption::s_nComboStyle		= SKN_COMBO_STYLE_DEFAULT;
int 	CSkinOption::s_nTabStyle		= SKN_TAB_STYLE_DEFAULT;
int 	CSkinOption::s_nRebarBGStyle	= SKN_REBAR_STYLE_TILE;
int 	CSkinOption::s_nRebarNoBoader	= SKN_CONST_NO_INT;
int 	CSkinOption::s_nStatusStyle 	= SKN_STATUS_STYLE_TILE;
int 	CSkinOption::s_nStatusTextColor = -1;						//+++
int 	CSkinOption::s_nStatusBackColor = -1;						//+++
int 	CSkinOption::s_nMainFrameBgColor= -1;						//+++
int 	CSkinOption::s_nMainFrameCaption= SKN_CONST_YES_INT;		//+++
int 	CSkinOption::s_nMenuStyle		= SKN_MENU_STYLE_TINY;		//+++


int CSkinOption::GetIntegerFromStringConst(const CString &strConst, int dflt)
{
	if		(strConst == SKN_CONST_DEFAULT) return SKN_CONST_DEFAULT_INT;
	else if (strConst == SKN_CONST_CLASSIC) return SKN_CONST_CLASSIC_INT;
	else if (strConst == SKN_CONST_THEME  ) return SKN_CONST_THEME_INT;
	else if (strConst == SKN_CONST_TILE   ) return SKN_CONST_TILE_INT;
	else if (strConst == SKN_CONST_STRETCH) return SKN_CONST_STRETCH_INT;
	else if (strConst == SKN_CONST_YES	  ) return SKN_CONST_YES_INT;
	else if (strConst == SKN_CONST_NO	  ) return SKN_CONST_NO_INT;
	else if (strConst == SKN_CONST_TINY   ) return SKN_CONST_TINY_INT;		//+++
	else if (strConst == SKN_CONST_ENGLISH) return SKN_CONST_ENGLISH_INT;	//+++
	else if (strConst.IsEmpty() == 0 && std::isxdigit(strConst[0])) return GetRGBval(strConst); //+++
	else									return dflt/*0*/;
}



#if 1	//+++
int CSkinOption::GetRGBval(const CString& str)
{
	LPCTSTR s	= str;
	//+++ 蔲 TCHAR=charO...
	DWORD	col = std::strtol((char*)s, NULL, 16);
	//+++ win̕`摤(brush)bgr̂悤HȂ̂ŁAr,bւ...
	col 		= ((col >> 16) & 0xFF) | (col & 0x00ff00) | ((col & 0xff) << 16) ;
	return col;
}
#endif



__inline int CSkinOption::QueryValueCustom(CIniFileI &pr, LPCTSTR lpKey, int dflt)
{
  #if 1 //+++ ƕobt@炷
	return GetIntegerFromStringConst( pr.GetString( lpKey ), dflt );
  #else
	CString strValue;
	DWORD	dwCount = MAX_PATH;
	pr.QueryValue(strValue.GetBuffer(MAX_PATH), lpKey, &dwCount);
	strValue.ReleaseBuffer();
	return GetIntegerFromStringConst(strValue);
  #endif
}



void CSkinOption::GetProfile()
{
	CString 	strSkinPath = _GetSkinDir() + "skin.ini";

	CIniFileI	pr( strSkinPath, _T("Interface") );
	s_nTabStyle 		= QueryValueCustom( pr, _T("TabStyle")	);
	s_nComboStyle		= QueryValueCustom( pr, _T("ComboStyle")	);
	s_nRebarBGStyle 	= QueryValueCustom( pr, _T("RebarBGStyle") );
	s_nRebarNoBoader	= QueryValueCustom( pr, _T("RebarNoBoader"));
	s_nStatusStyle		= QueryValueCustom( pr, _T("StatusStyle")	);
	s_nStatusTextColor	= QueryValueCustom( pr, _T("StatusTextColor" ), -1 );	//+++
	s_nStatusBackColor	= QueryValueCustom( pr, _T("StatusBackColor" ), -1 );	//+++
	s_nMainFrameBgColor = QueryValueCustom( pr, _T("MainFrameBgColor"), -1 );	//+++
	s_nMainFrameCaption = QueryValueCustom( pr, _T("MainFrameCaption"),  1 );	//+++
	s_nMenuStyle		= QueryValueCustom( pr, _T("MenuStyle") );				//+++
	pr.Close();
}



////////////////////////////////////////////////////////////////////////////////
//CSkinPropertyPage̒`
////////////////////////////////////////////////////////////////////////////////

CSkinPropertyPage::CSkinPropertyPage(HWND hTopWindow, BOOL *pbSkinChange)
	: m_bInit(FALSE)
	, m_hTopWindow(hTopWindow)
	, m_pbChanged(pbSkinChange)
{
}



void CSkinPropertyPage::_SetData()
{
	CString   strPath	  = _GetSkinDir();

	strPath.TrimRight( _T("\\") );
	strPath = strPath.Mid(strPath.ReverseFind('\\') + 1);

	CStatic   stName	  = GetDlgItem(IDC_STATIC_NAME);
	CStatic   stDesc	  = GetDlgItem(IDC_STATIC_DESC);
	CListBox  List		  = GetDlgItem(IDC_LIST_SKIN);

	stName.SetWindowText(strPath);

	//tH_
	CString 	strSkinPath = GetExeDirectory() + _T("Skin\\*");
	CFindFile	find;

	if ( find.FindFile(strSkinPath) ) {
		do {
			if ( find.IsDirectory() ) {
				CString strTitle = find.GetFileTitle();

				if ( strTitle != _T("") && strTitle != _T(".") ) {
					int 	nRet		= List.AddString( find.GetFileTitle() );
				  #if 1 //+++
					LPTSTR	lpstr		= _AllocString( find.GetFilePath() ); //newŊm K_FreeStringĂԂ
				  #else
					LPTSTR	lpstr		= _AllocString(); //newŊm K_FreeStringĂԂ
					CString strFilePath = find.GetFilePath();
					lstrcpy( lpstr, strFilePath.GetBuffer(0) );
				  #endif
					List.SetItemData(nRet, (DWORD_PTR) lpstr);
				}
			}
		} while ( find.FindNextFile() );

		find.Close();
	}

	List.SetCurSel(0);

	BOOL	  bHandled	  = FALSE;
	OnSelChanged(0, 0, NULL, bHandled);
}



LRESULT CSkinPropertyPage::OnSelChanged(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL &bHandled)
{
	CStatic 	label		= GetDlgItem(IDC_STATIC_DESC);
	CListBox	List		= GetDlgItem(IDC_LIST_SKIN);
	int 		nIndex		= List.GetCurSel();

	if (nIndex == LB_ERR)
		return 0;

  #if 1 //+++ ƕobt@炷.
	CString 	strSkinPath = (LPTSTR) List.GetItemData(nIndex);
	strSkinPath += _T("\\Skin.ini");
	CIniFileI	pr( strSkinPath, _T("Interface") );
	CString 	strBuf = pr.GetString( _T("Description") /*, NULL, 1024 */ );
	pr.Close();
  #else
	CIniFileI	pr;
	CString 		strSkinPath = (LPTSTR) List.GetItemData(nIndex);
	strSkinPath += _T("\\Skin.ini");
	pr.Open( strSkinPath, _T("Interface") );
	CString 		strBuf;
	DWORD			dwSize		= 1024;
	pr.QueryValue(strBuf.GetBuffer(1024), _T("Description"), &dwSize);
	strBuf.ReleaseBuffer();
	pr.Close();
  #endif
	strBuf.Replace( _T("\\n"), _T("\r\n") );

	label.SetWindowText(strBuf);

	return 0;
}



LRESULT CSkinPropertyPage::OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL & /*bHandled*/)
{
	CListBox List	= GetDlgItem(IDC_LIST_SKIN);
	int 	 nCount = List.GetCount();

	for (int i = 0; i < nCount; i++) {
		LPTSTR lpstr = (LPTSTR) List.GetItemData(i);
		_FreeString(lpstr);
		List.SetItemData(i, 0); //+++ delete̓NA.
	}

	return 1;
}



LRESULT CSkinPropertyPage::OnSkinApply(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	CListBox List		 = GetDlgItem(IDC_LIST_SKIN);
	int 	 index		 = List.GetCurSel();

	if (index == LB_ERR)
		return 0;

	CString  strPath	 = (LPTSTR) List.GetItemData(index);

	CString  strSkinPath = GetExeDirectory() + _T("Skin\\");

	if (strPath.Find(strSkinPath) == 0) {
		CString strName = strPath.Mid( strSkinPath.GetLength() );

		if ( !strName.IsEmpty() ) {
			CIniFileO	pr( g_szIniFileName, _T("Skin") );
			pr.SetValue( strName, _T("SkinFolder") );
			pr.Close();
			::SendMessage(m_hTopWindow, WM_CHANGE_SKIN, 0, 0);

			if (m_pbChanged)
				*m_pbChanged = TRUE;
		}
	}

	return 0;
}



BOOL CSkinPropertyPage::OnSetActive()
{
	if (!m_bInit) {
		m_bInit = TRUE;
		_SetData();
	}

	SetModified(TRUE);
	return TRUE;
}


#if 1	//+++

LPTSTR CSkinPropertyPage::_AllocString(const CString& str)
{
	DWORD	l	= str.GetLength();
	TCHAR*	buf = new TCHAR[l + 1];
	if (buf) {
		memcpy(buf, LPCTSTR(str), l);
		buf[l] = 0;
	}
	return buf;
}

#else
LPTSTR CSkinPropertyPage::_AllocString()
{
	return new TCHAR[MAX_PATH];
}
#endif



void CSkinPropertyPage::_FreeString(LPTSTR lpstr)
{
	delete[] lpstr;
}
